
Redmine - Patch #32196

Allow import time entries for other users

2019-10-04 13:30 - Marius BĂLTEANU

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Time tracking Estimated time: 0.00 hour

Target version:    

Description

#28234 allows importing time entries only for the current user. I think we should support importing for other users as well and I see

two options:

1. We allow based on the new permission "Log spent time for other users" added in #3848.

2. We add a new permission "Import time entries" as we already have for issues.

On the long term, I think option 2 it's better because:

- it's consistent with the behaviour from issues

- we can allow importing time entries on multiple projects once.

Any feedback is welcome.

Related issues:

Related to Redmine - Feature #28234: Add CSV Import for Time Entries Closed

Related to Redmine - Feature #3848: Permission to log time for another user Closed 2009-09-11

Associated revisions

Revision 18878 - 2019-10-28 15:02 - Go MAEDA

Add permission to import time entries (#32196, #28234).

Patch by Marius BALTEANU.

Revision 18890 - 2019-11-02 09:23 - Jean-Philippe Lang

Allow import time entries for other users (#32196).

Patch by Marius BALTEANU.

Revision 18891 - 2019-11-02 12:51 - Jean-Philippe Lang

Identify time entry user just like issue assignee (#32196).

Revision 18893 - 2019-11-02 14:22 - Jean-Philippe Lang

Fixed i18n string for permission (#32196).

Revision 18894 - 2019-11-02 15:39 - Jean-Philippe Lang

Restore label_import_time_entries i18n string (#32196).

History

#1 - 2019-10-04 13:30 - Marius BĂLTEANU

- Related to Feature #28234: Add CSV Import for Time Entries added

#2 - 2019-10-08 03:41 - Kevin Fischer

+1

Sounds good.

I also agree that option 2 would be better.

#3 - 2019-10-19 10:43 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU
- Target version set to Candidate for next major release

#4 - 2019-10-22 05:25 - Bernhard Rohloff

- Category set to Time tracking

+1

I think option 2 is the better one, too.

#5 - 2019-10-27 09:53 - Marius BĂLTEANU

- Assignee deleted (Marius BĂLTEANU)

- Target version changed from Candidate for next major release to 4.1.0

#6 - 2019-10-27 09:53 - Marius BĂLTEANU

- File 0002-Allow-import-time-entries-for-other-users-if-current.patch added

- File 0001-Add-permission-to-import-time-entries.patch added

I'm attaching two patches:

1. 0001-Add-permission-to-import-time-entries.patch which adds the missing "Import time entries" permission. I think it is better to have this

permission in order to be consistent with import issues from CSV. Also, some Redmine administrators don't want to allow importing time entries from

CSV at all.

2. 0002-Allow-import-time-entries-for-other-users-if-current.patch which allows users with "log_time_for_other_users" permission to import time

entries for other users as well.

#7 - 2019-10-27 09:57 - Marius BĂLTEANU

- File deleted (0002-Allow-import-time-entries-for-other-users-if-current.patch)

#8 - 2019-10-27 09:57 - Marius BĂLTEANU

- File 0002-Allow-import-time-entries-for-other-users-if-current.patch added

#9 - 2019-10-27 09:58 - Marius BĂLTEANU

- File deleted (0002-Allow-import-time-entries-for-other-users-if-current.patch)

#10 - 2019-10-27 10:00 - Marius BĂLTEANU

- File 0002-Allow-import-time-entries-for-other-users-if-current.patch added

#11 - 2019-10-27 20:20 - Marius BĂLTEANU

- File deleted (0001-Add-permission-to-import-time-entries.patch)

#12 - 2019-10-27 20:22 - Marius BĂLTEANU

- File 0001-Add-permission-to-import-time-entries.patch added

#13 - 2019-10-27 22:35 - Marius BĂLTEANU

- File 0002-Allow-import-time-entries-for-other-users-if-current.patch added

- File select_user_id.png added

Made some minor changes to attachment:0002-Allow-import-time-entries-for-other-users-if-current.patch in order to allow selecting the user from

column mapping and not only from CSV.
select_user_id.png 

#14 - 2019-10-27 22:35 - Marius BĂLTEANU

- File deleted (0002-Allow-import-time-entries-for-other-users-if-current.patch)

#15 - 2019-10-28 01:56 - Go MAEDA

Marius BALTEANU wrote:

1. 0001-Add-permission-to-import-time-entries.patch which adds the missing "Import time entries" permission. I think it is better to have this

permission in order to be consistent with import issues from CSV. Also, some Redmine administrators don't want to allow importing time entries

from CSV at all.
 I agree. CSV import feature is a dangerous feature. A malicious or ignorant user can easily ruin the spent time page by bulk-importing junk data. so,

the permission is useful to prevent such incidents.

#16 - 2019-10-28 09:05 - Marius BĂLTEANU

- File deleted (0001-Add-permission-to-import-time-entries.patch)

#17 - 2019-10-28 09:07 - Marius BĂLTEANU

- File 0001-Add-permission-to-import-time-entries.patch added

Go MAEDA wrote:

Marius BALTEANU wrote:

1. 0001-Add-permission-to-import-time-entries.patch which adds the missing "Import time entries" permission. I think it is better to have

this permission in order to be consistent with import issues from CSV. Also, some Redmine administrators don't want to allow importing

time entries from CSV at all.

 I agree. CSV import feature is a dangerous feature. A malicious or ignorant user can easily ruin the spent time page by bulk-importing junk data.

so, the permission is useful to prevent such incidents.

 Great, thanks. I'm attaching a new version of the patch which checks for the proper permission in /app/views/timelog/index.html.erb.

I think now both patches are ready for commit as part of #28234.

#18 - 2019-10-28 14:24 - Go MAEDA

- Related to Feature #3848: Permission to log time for another user added

#19 - 2019-10-29 02:57 - Go MAEDA

Regarding the patch 0002-Allow-import-time-entries-for-other-users-if-current.patch, I think the field mapping for the User field should default to the

current user for the consistency with the behavior when the current user does not have "Import time entries" permission.

When a user does not have "Import time entries" permission, the user cannot (and does not necessary to) to set field mapping for the User field and

data are always imported as their own time entries.

But when a user has the permission, the same operation results in an error saying that "User cannot be blank. User is invalid".

This can be resolved if the User field defaults to the current user.

#20 - 2019-10-29 09:03 - Marius BĂLTEANU

Go MAEDA wrote:

Regarding the patch 0002-Allow-import-time-entries-for-other-users-if-current.patch, I think the field mapping for the User field should default to

the current user for the consistency with the behavior when the current user does not have "Import time entries" permission.

When a user does not have "Import time entries" permission, the user cannot (and does not necessary to) to set field mapping for the User field

and data are always imported as their own time entries.

But when a user has the permission, the same operation results in an error saying that "User cannot be blank. User is invalid".

This can be resolved if the User field defaults to the current user.

 Agree with you, I'll post the updated patch these days.

#21 - 2019-10-31 10:23 - Dominik Ras

+1 for option 2

+100 for the whole concept of adding time for other users (with sufficient permissions!!). That will save several man-days a month. You guys ROCK !!

#22 - 2019-11-01 23:03 - Marius BĂLTEANU

- File deleted (0002-Allow-import-time-entries-for-other-users-if-current.patch)

#23 - 2019-11-01 23:03 - Marius BĂLTEANU

- File 0001-Allow-import-time-entries-for-other-users.patch added
Updated the second patch.

#24 - 2019-11-02 08:50 - Jean-Philippe Lang

Marius BALTEANU wrote:

Updated the second patch.

 Thanks Marius. With this implementation, we can reference users with their numeric ids only. That can be a pain to fill/review in the CSV file. Is it OK

or should we allow to use usernames or emails?

#25 - 2019-11-02 09:04 - Marius BĂLTEANU

Jean-Philippe Lang wrote:

Thanks Marius. With this implementation, we can reference users with their numeric ids only. That can be a pain to fill/review in the CSV file. Is it

OK or should we allow to use usernames or emails?

 I think it's good enough to allow user ids in a first phase and then add support for usernames or emails in 4.1.1.

#26 - 2019-11-02 09:19 - Marius BĂLTEANU

Anyway, I'll try to update my patch in the following 2 or 3 hours.

#27 - 2019-11-02 09:20 - Jean-Philippe Lang

Marius BALTEANU wrote:

Anyway, I'll try to update my patch in the following 2 or 3 hours.

 No I think it's OK for now.

#28 - 2019-11-02 09:21 - Marius BĂLTEANU

Jean-Philippe Lang wrote:

Marius BALTEANU wrote:

Anyway, I'll try to update my patch in the following 2 or 3 hours.

 No I think it's OK for now.

 Ok, thanks for you quick response.

#29 - 2019-11-02 09:24 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

Committed, thanks.

#30 - 2019-11-02 12:53 - Jean-Philippe Lang

Marius BALTEANU wrote:

I think it's good enough to allow user ids in a first phase and then add support for usernames or emails in 4.1.1.

 I made the change in order to reference users just like we reference assignees when importing issues.

#31 - 2019-11-02 14:50 - Marius BĂLTEANU

- File import_new.png added

- Status changed from Closed to Reopened

r18893 broke the translation in time_entries/imports/new:
 import_new.png 

I think we need to add both keys in the locales (as we have for issues). Sorry for not catching this.

#32 - 2019-11-02 14:52 - Marius BĂLTEANU

Also, I propose to remove this ticket from 4.1.0  because it will appear in the changelog as  part of #3848 and #28234.

#33 - 2019-11-02 15:39 - Jean-Philippe Lang

- Status changed from Reopened to Closed

- Target version deleted (4.1.0)

Marius BALTEANU wrote:

I think we need to add both keys in the locales (as we have for issues). Sorry for not catching this.

 Fixed, thanks for pointing this out.

Files

select_user_id.png 296 KB 2019-10-27 Marius BĂLTEANU

0001-Add-permission-to-import-time-entries.patch 4 KB 2019-10-28 Marius BĂLTEANU

0001-Allow-import-time-entries-for-other-users.patch 9.72 KB 2019-11-01 Marius BĂLTEANU

import_new.png 55.1 KB 2019-11-02 Marius BĂLTEANU
